/*
 * $Id: curdef.h,v 0.91 1994/02/20 00:53:41 zhao Pre-Release $
 *
 *. This file is part of BIT shareware package. After the two weeks of
 *  free evaluation period, you are encouraged (required) to register
 *  your copy for a small registration fee, which is $35 for personal use
 *  and $50 for commercial, government and institutional use.
 *
 *  Copyright(c) 1993, 1994 by T.C. Zhao.
 *  All rights reserved.
 *
 *  Permission to use, copy, and distribute this software in its entirety
 *  for non-commercial purposes is hereby granted, provided that the
 *  above shareware and copyright notices and this permission notice
 *  appear in all copies and their documentation.
 *
 *  This software may be modified for your own use, but modified versions
 *  may not be distributed without prior consent of the author.
 *
 *  This software is provided "as is" without expressed or implied
 *  warranty of any kind.
 *
 *.
 */
#ifndef CURDEFS_H_
#define CURDEFS_H_

/************************************************************
 * All cursor names, which also servers as the indeces into
 * cursor glyph tables. Order is not important, although a serious
 * of similar cursors must be consecutive.
 ************************************************************/

typedef enum
  {
      CUR_DEFAULT, CUR_S_CROSS,
      CUR_BUSY, CUR_HAND, CUR_S_FRECT,
      CUR_RECT10, CUR_RECT20, CUR_RECT30,
      CUR_S_DISK,
      CUR_ROT1, CUR_ROT2, CUR_ROT3, CUR_ROT4,
      CUR_V_LINE, CUR_H_LINE, CUR_L_LINE, CUR_R_LINE,
      CUR_CIRC10, CUR_CIRC20, CUR_CIRC30, CUR_CIRCNET,
      CUR_FREE1, CUR_FREE2
  }

Cur_name;

/** Free index */
enum
  {
      FREE_R_SLANT, FREE_L_SLANT
  };

extern void init_cursor(void);
extern void set_cursor(long, int);
extern void reset_cursor(long);
extern void set_default_cursor(long, int);
extern void set_cursor_color(int *);
extern void get_cursor_color(int *);
extern int rotate_circle_cursor(long);
extern int make_cursor(int, int);

#endif
